#include <MIDI.h>  // Add Midi Library
#include <Button.h> //Debounce library
#include "LedControlMS.h"
MIDI_CREATE_DEFAULT_INSTANCE();
//BUTTONS
Button Devbutton[] = {Button(2, LOW), Button(3, LOW), Button(4, LOW), Button(5, LOW), Button(6, LOW), Button(7, LOW)} ;
//LEDS
int led1 = 12;
int led2 = 13;
//ON BOARD POT
int pot_Pin = A0;
int pot_Value = 0;
int pot_Anterior = 0;
//EXP PEDAL
int exp_Pin = A1;
int exp_Value = 0;
int exp_Anterior = 0;
//CLOCK COUNT
int clockCount = -1;
//BANKS
const int numBanks = 20;
int currentBank = 1;
int previousBank = 1;
////int displayArray [] = {8,9,10,11};
//NEW DISPLAY PINS
int latchPin = 9;
int clockPin = 10;
int dataPin = 8;

unsigned long showPotValue = 0;

//DISPLAY VARS
LedControl lc=LedControl(dataPin,clockPin,latchPin,3);
unsigned long delaytime=550;//  v*75
//byte disp[] = {0, 0, 0};
//byte index[] = {32, 64, 128};
byte val = 0;
word counter = 0;
//
int prevHold = 0;
int nextHold = 0;
int holdTime = 1000;

//DOUBLE CLICK
boolean doubleClick = false;
int pressedTime = 0;
int pressTime = 0;
int releasedTime = 0;
int releaseTime = 0;
int dCtime = 200;
boolean waitForDC = true;
boolean isDC = false;
boolean midiSend = false;

// -----------------------------------------------------------------------------
//CALLBACKS
//CLOCK HANDLE
void clockIn() {
   switch (clockCount) {
    case -1:
       break; 
    case 0:
       digitalWrite(led1, HIGH);
       clockCount++;
       break;
    case 2:
      digitalWrite(led1, LOW);
       clockCount++;
       break;
       
    case 23:
       clockCount = 0;
       break;
    default: 
       clockCount++;
       break;
  }
  
}

//START HANDLE
void startIn() {
  //digitalWrite(led1, HIGH);  
  clockCount = 0;
}
//STOP HANDLE
void stopIn() {
   digitalWrite(led1, LOW); 
   clockCount = -1;
}

// -----------------------------------------------------------------------------

void setup() {
     /*
   The MAX72XX is in power-saving mode on startup,
   we have to do a wakeup call
   */
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,15);
  /* and clear the display */
  lc.clearDisplay(0);
  
  //LEDS
  pinMode(led1, OUTPUT); 
  pinMode(led2, OUTPUT);
  //ON BOARD POT
  pot_Value = analogRead(pot_Pin);
  pot_Value = map(pot_Value, 0, 1023, 0, 127);
  pot_Anterior = pot_Value; 
  //EXP PEDAL POT
  exp_Value = analogRead(exp_Pin);
  exp_Value = map(exp_Value, 0, 1023, 0, 127);
  exp_Anterior = exp_Value;   
 
  
  
  //BUTTONS
 
    pinMode(2, INPUT_PULLUP);    
    pinMode(3, INPUT_PULLUP);
    pinMode(4, INPUT_PULLUP);
    pinMode(5, INPUT_PULLUP);
    pinMode(6, INPUT_PULLUP);
    pinMode(7, INPUT_PULLUP);
    Devbutton[4].setHoldDelay(holdTime);
    Devbutton[5].setHoldDelay(holdTime);
  
  // START DISPLAY
  counter = word(currentBank);
  
  
  
  //READ CALLBACKS
  
  //CONTROL CHANGE SET HANDLE
 // MIDI.setHandleControlChange(controlChangeIn);  
  //CLOCK SET HANDLE
  MIDI.setHandleClock(clockIn);
  //START SET HANDLE
  MIDI.setHandleStart(startIn);
  //STOP SET HANDLE
  MIDI.setHandleStop(stopIn);
  
  // Initiate MIDI
  MIDI.begin(MIDI_CHANNEL_OMNI);
  //
 
}

void loop() {
 // updateShiftRegisters();
  //ONBOARD POT
  pot_Value = analogRead(pot_Pin);
  pot_Value = map(pot_Value, 0, 1023, 0, 127); 
  if(pot_Anterior != pot_Value )
  {
    int value = pot_Anterior - pot_Value;
    int absValue = abs(value);
      if(absValue > 1){
         MIDI.sendControlChange(25,pot_Value,1);
         //changeDisplayValue(pot_Value);
          printNumber(pot_Value);
         pot_Anterior = pot_Value; 
         showPotValue = millis(); 
      }
  }
  
  //EXP PEDAL POT
  exp_Value = analogRead(exp_Pin);
  exp_Value = map(exp_Value, 0, 1023, 0, 127); 
  if(exp_Anterior != exp_Value )
  {
    int valueExp = exp_Anterior - exp_Value;
    int absValueExp = abs(valueExp);
      if(absValueExp > 1){
         MIDI.sendControlChange(50,exp_Value,1);
         //changeDisplayValue(exp_Value);
          printNumber(exp_Value);
         exp_Anterior = exp_Value;
         showPotValue = millis(); 
      }
  }
  //DISPLAY DATA
  if (showPotValue != 0){
     unsigned long elapsedTime = millis();
     if(elapsedTime - showPotValue > 2000){
       //changeDisplayValue(currentBank);
        printNumber(currentBank);
       showPotValue = 0;
     }
  }
  
  //READ
  MIDI.read();
    
  //BUTTONS LOOP
    
  Devbutton[0].listen();
  Devbutton[1].listen();
  Devbutton[2].listen();
  Devbutton[3].listen();
  Devbutton[4].listen();
  Devbutton[5].listen();
 
  
  
  //CONTROL BUTTONS  
  //1
  if (Devbutton[0].onPress()) {
     MIDI.sendNoteOn(0+(12*(currentBank)),127,1);
  } 
  if (Devbutton[0].onRelease()) {
     MIDI.sendNoteOff(0+(12*(currentBank)),0,1);
  }
  //2
  if (Devbutton[1].onPress()) {
     MIDI.sendNoteOn(1+(12*(currentBank)),127,1);
  } 
  if (Devbutton[1].onRelease()) {
     MIDI.sendNoteOff(1+(12*(currentBank)),0,1);
  }
  //3
  if (Devbutton[2].onPress()) {
    MIDI.sendNoteOn(2+(12*(currentBank)),127,1);
  } 
  if (Devbutton[2].onRelease()) {
     MIDI.sendNoteOff(2+(12*(currentBank)),0,1);
  }
  //4 
  // Al Apretar
  if(Devbutton[3].onPress()){
    //Guarda el tiempo al apretar
    pressTime = millis();
    //chequea cuantas veces se ha apretado el boton
    //La primera vez que se ha apretado
    if(Devbutton[3].getPressCount() == 1){
      //Avisa para que se espere al DC
       waitForDC = true;
       //Limpia el send
       midiSend = false;
       //Limpia el tiempo de soltado
       releasedTime = 0;
    }
    //La segunda vez que se ha apretado
    if(Devbutton[3].getPressCount() == 2){
      //Avisa para que no se espere al DC
       waitForDC = false;
       //Limpia la cuenta 
       Devbutton[3].clearPressCount();
       if(releasedTime-releaseTime < dCtime){
         //ENVIA LA SENIAL DC
          MIDI.sendNoteOn(3+6+(12*(currentBank)),127,1);
          delay(50);
          MIDI.sendNoteOff(3+6+(12*(currentBank)),0,1);
       }
    }
  }
  if (Devbutton[3].isPressed()) {
    //Guarda el tiempo que lleva apretado
     pressedTime = millis();
  }
  
  // Al Soltar
  
  if(Devbutton[3].onRelease()) {
    //Guarda el tiempo al soltar
    releaseTime = millis();
  }
  if(midiSend == false){
    if(Devbutton[3].isReleased()) {
       //Guarda el tiempo que lleva suelto
       releasedTime = millis();
       //Si se pasa el tiempo de DC sin apretar
       if(waitForDC == true && releasedTime-releaseTime > dCtime){
          //Avisa que se envia la nota normal
          midiSend = true;
          //Envia la senial midi normal
          MIDI.sendNoteOn(3+(12*(currentBank)),127,1);
          delay(50);
          MIDI.sendNoteOff(3+(12*(currentBank)),0,1);
          //Limpia la cuenta de apretado
          Devbutton[3].clearPressCount();
       }
    }
  }
 
 
  //PREV BANK BUTTON 
  if (Devbutton[4].onRelease()) {
     if(prevHold == 0){  
         prevBank();
      } 
      else 
      {
        prevHold = 0;
      }  
  } 
  //HOLD PREV BANK BUTTON
  if (Devbutton[4].isHold()) {
     
     if(prevHold == 0){
       if(currentBank != 0){
           //previousBank = currentBank;
          gotoMainBank();
          prevHold = 1;
       }else {
          gotoPrevBank();
          prevHold = 1;
       }
     }
  }
   
  //NEXT NEXT BUTTON 
  if (Devbutton[5].onRelease()) {
      if(nextHold == 0){
         nextBank();
      } 
      else 
      {
        nextHold = 0;
      }  
  }
  //HOLD NEXT BANK BUTTON
  if (Devbutton[5].isHold()) {
    if(  nextHold == 0){
     
      if(currentBank == 0){
          gotoPrevBank();
           nextHold = 1;
      }else {
         //previousBank = currentBank;
         gotoMainBank();
         nextHold = 1;
      }
    }
   }
}

//***************************************FIN LOOP

//PREV BANK 
void prevBank(){

  if(currentBank > 1){
    currentBank--;
  }else {
    currentBank = numBanks-1;
  }
  //changeDisplayValue(currentBank);
   printNumber(currentBank);
}

//NEXT BANK 
void nextBank(){

  if(currentBank < numBanks-1){
    currentBank++;
  }else {
    currentBank = 1;
  }
  //changeDisplayValue(currentBank);
   printNumber(currentBank);
}

//GO TO MAIN BANK 
void gotoMainBank(){
  
  if(currentBank != 0){
    previousBank = currentBank;
    currentBank = 0;
    //changeDisplayValue(currentBank);
     printNumber(currentBank);
  }
}

//BACK TO PREV BANK 
void gotoPrevBank(){
  if(currentBank == 0){
    currentBank = previousBank;
    //changeDisplayValue(currentBank);
    printNumber(currentBank);
  }
}


/*void displayBinary(byte numToShow)
{
  for (int i = 0; i < 4; i++)
  {
    if (bitRead(numToShow, i)==1)
    {
      digitalWrite(displayArray[i], HIGH);
    }
    else
    {
      digitalWrite(displayArray[i], LOW);
    }
  }
}

void updateShiftRegisters()
{
  for(int j=0; j<3; j++)
  {
    val = disp[j] + index[j];
    digitalWrite(latchPin, LOW);
    shiftOut(dataPin, clockPin, LSBFIRST, val);
    digitalWrite(latchPin, HIGH);
    delay(5);
    digitalWrite(latchPin, LOW);
    shiftOut(dataPin, clockPin, LSBFIRST, val);
    digitalWrite(latchPin, HIGH);
  }
}

void changeDisplayValue(byte numToShow){

 
  counter = word(numToShow);

  disp[2] = counter % 10;
  disp[1] = int(counter/ 10) % 10;
  disp[0] = int(counter/ 100) %10;
  
  updateShiftRegisters();
}*/

void printNumber(int v)
{
  int ones;
  int tens;
  int cent;
  boolean zero;   
  if(v < 0 || v > 999)
    return;
  ones=v%10;
  v=v/10;
  tens=v%10;
  v=v/10;
  cent=v%10;
  
  lc.setDigit(0,2,(byte)cent,false);
  lc.setDigit(0,1,(byte)tens,false);
  lc.setDigit(0,0,(byte)ones,false);
}

